Essential Go Panic and recover  Suggest an edit

Panic

A panic halts normal execution flow and exits the current function.

Any deferred calls will then be executed before control is passed to the next function higher on the stack.

Each stack’s function will exit and run deferred calls until the panic is handled using a deferred recover(), or until the panic reaches main() and terminates the program.

If this occurs, the argument provided to panic and a stack trace will be printed to stderr.

func foo() {
	defer fmt.Println("Exiting foo")
	panic("bar")
}

func main() {
	defer fmt.Println("Exiting main")
	foo()
}
Exiting foo
Exiting main
panic: bar

goroutine 1 [running]:
main.foo()
	/private/var/folders/2k/p2_4052s70vd5_cfdm0k0l740000gn/T/src205228285/main.go:9 +0x95
main.main()
	/private/var/folders/2k/p2_4052s70vd5_cfdm0k0l740000gn/T/src205228285/main.go:14 +0x7e
exit status 2

panic accepts any type as its parameter.

  ↑ ↓ to navigate     ↵ to select     Esc to close